#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <pthread.h>

int main ( int argc, char **argv )
{
    struct timespec delta, abstime;
    int status;
    pthread_mutex_t mut;
    pthread_cond_t cond;
    if ( argc < 2 ) exit(20);

    pthread_mutex_init ( &mut, pthread_mutexattr_default );
    pthread_cond_init ( &cond, pthread_condattr_default );

    delta.tv_sec = atoi(argv[1]);
    delta.tv_nsec = 0;

    status = pthread_get_expiration_np ( &delta, &abstime );
    printf("Status of get exp: %d, abstime: %d %d\n", status,
	abstime.tv_sec, abstime.tv_nsec );

    printf("Reconvert: %s\n", ctime(&abstime.tv_sec) );

    pthread_mutex_lock ( &mut );
    status = pthread_cond_timedwait ( &cond, &mut, &abstime );
    printf("Status of timedwait: %d\n", status );
}
